'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var language = require('@codemirror/language');
var langJavascript = require('@codemirror/lang-javascript');
var highlight = require('@lezer/highlight');
var common = require('@lezer/common');
var lr = require('@lezer/lr');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const JavascriptExpression = 1,
  Text = 2;

const percent = 37;
const closeAngle = 62;
const dash = 45;
const underscore = 95;
const javascriptExpressionOrText = new lr.ExternalTokenizer((input, stack) => {
    let { next } = input;
    while (next !== -1 &&
        next !== percent &&
        (input.peek(1) !== closeAngle ||
            ([dash, underscore].indexOf(input.peek(1)) > -1 &&
                input.peek(2) !== closeAngle))) {
        next = input.advance();
    }
    const token = stack.canShift(JavascriptExpression)
        ? JavascriptExpression
        : Text;
    input.acceptToken(token);
}, { contextual: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "!vOYQROOPbOPOOOgQRO'#CkOOQO'#Ck'#CkQOQPOOPlOSO'#C_POOO)C>])C>]OwQPO,59VPOOO'#Ce'#CeP|OSO,58yPOOO,58y,58yOOQO1G.q1G.qPOOO-E6c-E6cPOOO1G.e1G.e",
  stateData: "!X~O[OS]PQ~OQROVQO~O]TO~OPVO~OSWOTYO^WO~OWZO~OSWOT]O^WO~O",
  goto: "m`PPPaPPPPPdPPPPPjRUPQXTR[XRSO",
  nodeNames: "⚠ JavascriptExpression Text Comment CommentContent ClosingTag Program OpeningTag ClosingTag",
  maxTerm: 15,
  nodeProps: [
    ["closedBy", 7,"ClosingTag"],
    ["openedBy", 8,"OpeningTag"]
  ],
  skippedNodes: [0,3,4,5,9],
  repeatNodeCount: 1,
  tokenData: "$R~R^X^}pq}uv!r}!O#V!^!_#]#R#S#V#y#z}$f$g}#BY#BZ}$IS$I_}$I|$JO}$JT$JU}$KV$KW}&FU&FV}~!SY[~X^}pq}#y#z}$f$g}#BY#BZ}$IS$I_}$I|$JO}$JT$JU}$KV$KW}&FU&FV}~!uP!`!a!x~!}PW~~~#Q~#VOW~~#YPuv!r~#`Puv#c~#hTV~st#wuv#|}!O#|!_!`#|#R#S#|~#|O]~~$ROV~",
  tokenizers: [1, javascriptExpressionOrText, new lr.LocalTokenGroup("!O~RSYZ_uvd}!Ow#R#Sw~dO^~~gP!`!aj~oPT~~~r~wOT~~zPuvd~", 45, 4)],
  topRules: {"Program":[0,6]},
  tokenPrec: 0
});

const ejsLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                JavascriptExpression: language.delimitedIndent({ closing: "%>", align: false }),
            }),
            highlight.styleTags({
                "OpeningTag ClosingTag": highlight.tags.strong,
                CommentContent: highlight.tags.comment,
            }),
        ],
        wrap: common.parseMixed((node) => node.type.isTop
            ? {
                parser: langJavascript.javascriptLanguage.parser,
                overlay: (node) => node.type.name === "JavascriptExpression",
            }
            : null),
    }),
});
function ejs() {
    return new language.LanguageSupport(ejsLanguage, langJavascript.javascript().support);
}

exports.ejs = ejs;
exports.ejsLanguage = ejsLanguage;
