import { LRLanguage, indentNodeProp, delimitedIndent, LanguageSupport } from '@codemirror/language';
import { javascriptLanguage, javascript } from '@codemirror/lang-javascript';
import { styleTags, tags } from '@lezer/highlight';
import { parseMixed } from '@lezer/common';
import { ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const JavascriptExpression = 1,
  Text = 2;

const percent = 37;
const closeAngle = 62;
const dash = 45;
const underscore = 95;
const javascriptExpressionOrText = new ExternalTokenizer((input, stack) => {
    let { next } = input;
    while (next !== -1 &&
        next !== percent &&
        (input.peek(1) !== closeAngle ||
            ([dash, underscore].indexOf(input.peek(1)) > -1 &&
                input.peek(2) !== closeAngle))) {
        next = input.advance();
    }
    const token = stack.canShift(JavascriptExpression)
        ? JavascriptExpression
        : Text;
    input.acceptToken(token);
}, { contextual: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!vOYQROOPbOPOOOgQRO'#CkOOQO'#Ck'#CkQOQPOOPlOSO'#C_POOO)C>])C>]OwQPO,59VPOOO'#Ce'#CeP|OSO,58yPOOO,58y,58yOOQO1G.q1G.qPOOO-E6c-E6cPOOO1G.e1G.e",
  stateData: "!X~O[OS]PQ~OQROVQO~O]TO~OPVO~OSWOTYO^WO~OWZO~OSWOT]O^WO~O",
  goto: "m`PPPaPPPPPdPPPPPjRUPQXTR[XRSO",
  nodeNames: "⚠ JavascriptExpression Text Comment CommentContent ClosingTag Program OpeningTag ClosingTag",
  maxTerm: 15,
  nodeProps: [
    ["closedBy", 7,"ClosingTag"],
    ["openedBy", 8,"OpeningTag"]
  ],
  skippedNodes: [0,3,4,5,9],
  repeatNodeCount: 1,
  tokenData: "$R~R^X^}pq}uv!r}!O#V!^!_#]#R#S#V#y#z}$f$g}#BY#BZ}$IS$I_}$I|$JO}$JT$JU}$KV$KW}&FU&FV}~!SY[~X^}pq}#y#z}$f$g}#BY#BZ}$IS$I_}$I|$JO}$JT$JU}$KV$KW}&FU&FV}~!uP!`!a!x~!}PW~~~#Q~#VOW~~#YPuv!r~#`Puv#c~#hTV~st#wuv#|}!O#|!_!`#|#R#S#|~#|O]~~$ROV~",
  tokenizers: [1, javascriptExpressionOrText, new LocalTokenGroup("!O~RSYZ_uvd}!Ow#R#Sw~dO^~~gP!`!aj~oPT~~~r~wOT~~zPuvd~", 45, 4)],
  topRules: {"Program":[0,6]},
  tokenPrec: 0
});

const ejsLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                JavascriptExpression: delimitedIndent({ closing: "%>", align: false }),
            }),
            styleTags({
                "OpeningTag ClosingTag": tags.strong,
                CommentContent: tags.comment,
            }),
        ],
        wrap: parseMixed((node) => node.type.isTop
            ? {
                parser: javascriptLanguage.parser,
                overlay: (node) => node.type.name === "JavascriptExpression",
            }
            : null),
    }),
});
function ejs() {
    return new LanguageSupport(ejsLanguage, javascript().support);
}

export { ejs, ejsLanguage };
